﻿Imports System
Imports System.Collections
Imports System.Configuration
Imports System.Data
Imports System.Linq
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.HtmlControls
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Xml.Linq
Imports DotNetNuke
Imports DotNetNuke.Security
Imports LinqThings4SaleVB
Imports DotNetNuke.Common
Namespace DotNetNuke.Modules.LinqThings4SaleVB
    Partial Public Class EditItem
        Inherits DotNetNuke.Entities.Modules.PortalModuleBase
#Region "QueryString"
        Public ReadOnly Property RecordID() As Integer
            Get
                If Request.QueryString("RecordID") Is Nothing Then
                    Return 0
                Else
                    Return Convert.ToInt16(Request.QueryString("RecordID"))
                End If
            End Get
        End Property
#End Region
        Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
            If UserId = -1 Then
                lnkBack.Text = "You must be logged in to add or edit a listing"
                pnlEditItem.Visible = False
            Else
                If RecordID = -1 Then
                    FVItem.ChangeMode(FormViewMode.Insert)
                Else
                    If PortalSecurity.IsInRole("Administrators") OrElse AllowedToEdit() Then
                        FVItem.ChangeMode(FormViewMode.Edit)
                    Else
                        lnkBack.Text = "You are not allowed to edit this listing"
                        pnlEditItem.Visible = False
                    End If
                End If
            End If
        End Sub
        Private Function AllowedToEdit() As Boolean
            Dim LinqThings4SaleVBDataContext As New LinqThings4SaleVBDataContext()
            Dim result = From item In LinqThings4SaleVBDataContext.ThingsForSales _
            Where item.ID = RecordID And item.UserID = UserId _
            Select item
            Return (result.Count() > 0)
        End Function
#Region "LinqDataSource Events"
        Protected Sub LDSEditItem_Selecting(ByVal sender As Object, ByVal e As LinqDataSourceSelectEventArgs)
            e.WhereParameters("ModuleId") = ModuleId
            e.WhereParameters("ID") = RecordID
        End Sub
        Protected Sub LDSEditItem_Inserting(ByVal sender As Object, ByVal e As LinqDataSourceInsertEventArgs)
            Dim ThingsForSale As ThingsForSale = DirectCast(e.NewObject, ThingsForSale)
            ThingsForSale.UserID = Entities.Users.UserController.GetCurrentUserInfo().UserID
            ThingsForSale.ModuleId = ModuleId
        End Sub
#End Region
#Region "LinkButton Events"
        Protected Sub lnkBack_Click(ByVal sender As Object, ByVal e As EventArgs)
            Response.Redirect(Globals.NavigateURL(), True)
        End Sub
        Protected Sub LDSEditItem_Inserted(ByVal sender As Object, ByVal e As LinqDataSourceStatusEventArgs)
            Response.Redirect(Globals.NavigateURL(), True)
        End Sub
        Protected Sub LDSEditItem_Updated(ByVal sender As Object, ByVal e As LinqDataSourceStatusEventArgs)
            Response.Redirect(Globals.NavigateURL(), True)
        End Sub
        Protected Sub InsertCancelButton_Click(ByVal sender As Object, ByVal e As EventArgs)
            Response.Redirect(Globals.NavigateURL(), True)
        End Sub
        Protected Sub LDSEditItem_Deleted(ByVal sender As Object, ByVal e As LinqDataSourceStatusEventArgs)
            Response.Redirect(Globals.NavigateURL(), True)
        End Sub
        Protected Sub UpdateCancelButton_Click(ByVal sender As Object, ByVal e As EventArgs)
            Response.Redirect(Globals.NavigateURL(), True)
        End Sub
#End Region
    End Class
End Namespace

