﻿Imports System
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Imports System.Data
Imports System.Linq
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.HtmlControls
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Xml.Linq
Imports DotNetNuke
Imports DotNetNuke.Security
Imports LinqThings4SaleVB
Imports DotNetNuke.Entities.Modules
Imports DotNetNuke.Common
Namespace DotNetNuke.Modules.LinqThings4SaleVB
    Partial Public Class View
        Inherits DotNetNuke.Entities.Modules.PortalModuleBase
        Implements Entities.Modules.IActionable
        Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
            If UserId <> -1 Then
                lnkAddListing.Text = "[Add My Listing]"
                lnkAddListing.Enabled = True
            Else
                lnkAddListing.Text = "You must be logged in to add a Listing"
                lnkAddListing.Enabled = False
            End If

        End Sub
#Region "LinkButton Events"
        Protected Sub lnkAddListing_Click(ByVal sender As Object, ByVal e As EventArgs) Handles lnkAddListing.Click
            Dim objModules As New ModuleController()
            Response.Redirect(Globals.NavigateURL(PortalSettings.ActiveTab.TabID, "EditItem", "mid=" + ModuleId.ToString(), "RecordID=-1"))
        End Sub
#End Region
#Region "IActionable Members"
        Public ReadOnly Property ModuleActions() As DotNetNuke.Entities.Modules.Actions.ModuleActionCollection Implements Entities.Modules.IActionable.ModuleActions
            Get
                Dim Actions As New Entities.Modules.Actions.ModuleActionCollection()
                Actions.Add(GetNextActionID(), "Edit Categories", Entities.Modules.Actions.ModuleActionType.AddContent, "", "", EditUrl(), _
                False, SecurityAccessLevel.Edit, True, False)
                Return Actions
            End Get
        End Property
#End Region
#Region "LinqDataSource"
        Protected Sub LDSGrouping_Selecting(ByVal sender As Object, ByVal e As LinqDataSourceSelectEventArgs) Handles LDSGrouping.Selecting
            e.WhereParameters("ModuleId") = ModuleId
        End Sub
#End Region
#Region "ViewState"
        <Serializable()> _
        Public Class Category
            Dim _Name As String
            Public Property Name() As String
                Get
                    Return _Name
                End Get
                Set(ByVal value As String)
                    _Name = value
                End Set
            End Property
        End Class
        Public Property Categories() As List(Of Category)

            Get
                If ViewState("Categories") Is Nothing Then
                    Return New List(Of Category)()
                Else
                    Return DirectCast(ViewState("Categories"), List(Of Category))
                End If
            End Get
            Set(ByVal value As List(Of Category))
                ViewState("Categories") = value
            End Set
        End Property
#End Region

#Region "ListView"
        Protected Sub lvItems_ItemDataBound(ByVal sender As Object, ByVal e As ListViewItemEventArgs)
            Dim LinkButton As LinkButton = DirectCast(e.Item.FindControl("lnkSelect"), LinkButton)

            If (Not PortalSecurity.IsInRole("Administrators")) And Not (Entities.Users.UserController.GetCurrentUserInfo().UserID = Convert.ToInt16(LinkButton.CommandArgument)) Then
                e.Item.Controls(1).Visible = False
            End If
        End Sub
        Protected Sub LVGroup_ItemDataBound(ByVal sender As Object, ByVal e As ListViewItemEventArgs)
            Dim Panel As Panel = DirectCast(e.Item.FindControl("pnlItems"), Panel)
            Dim objLinkButton As LinkButton = DirectCast(e.Item.FindControl("MinMax"), LinkButton)
            Dim results = From cat In Categories _
                          Where cat.Name = objLinkButton.CommandArgument _
                          Select cat
            If results.Count() <> 0 Then
                Panel.Visible = True
                objLinkButton.Text = "-"
            End If
        End Sub
#End Region
#Region "MinMax"
        Protected Sub MinMax_Click(ByVal sender As Object, ByVal e As EventArgs)
            Dim objLinkButton As LinkButton = DirectCast(sender, LinkButton)
            Dim results = From cat In Categories _
                          Where cat.Name = objLinkButton.CommandArgument _
                          Select cat
            If objLinkButton.Text = "+" Then
                If results.Count() = 0 Then
                    Dim objCategory As New Category
                    objCategory.Name = objLinkButton.CommandArgument
                    Dim colCategories As List(Of Category) = Categories
                    colCategories.Add(objCategory)
                    Categories = colCategories
                End If
            Else
                If results.Count() <> 0 Then
                    Dim colCategories As List(Of Category) = Categories
                    Dim objCategory As Category
                    objCategory = colCategories.FirstOrDefault(Function(c) c.Name = objLinkButton.CommandArgument)
                    colCategories.Remove(objCategory)
                    Categories = colCategories
                End If
            End If
            LVGroup.DataBind()
        End Sub
#End Region

        Protected Sub lnkSelect_Click(ByVal sender As Object, ByVal e As EventArgs)
            Dim objLinkButton As LinkButton = DirectCast(sender, LinkButton)

            Response.Redirect(Globals.NavigateURL(PortalSettings.ActiveTab.TabID, "EditItem", "mid=" + ModuleId.ToString(), "RecordID=" + objLinkButton.CommandName))
        End Sub

    End Class
End Namespace

